import type { Readable, Subscriber, Unsubscriber } from 'svelte/store';
export declare type Proxify<T extends object> = {
    [K in keyof T]: T[K] extends object ? Proxify<T[K]> : T[K];
} & {
    subscribe: (run: Subscriber<T>) => Unsubscriber;
    $key: <K extends keyof T = keyof T>(key: K) => Readable<T[K]>;
};
export declare const proxy: <T extends object>(obj: T) => Proxify<T>;
