import { proxy as valtioProxy, snapshot, subscribe } from 'valtio/vanilla';
import { subscribeKey } from 'valtio/utils';
export const proxy = (obj) => {
    const p = valtioProxy(obj);
    addStoreMethods(p);
    return p;
};
const addStoreMethods = (obj) => {
    obj.subscribe = (run) => {
        run(snapshot(obj));
        return subscribe(obj, () => run(snapshot(obj)));
    };
    obj.$key = (key) => ({
        subscribe: (run) => {
            run(snapshot(obj)[key]);
            return subscribeKey(obj, key, () => {
                run(snapshot(obj)[key]);
            });
        }
    });
    Object.keys(obj).forEach(key => {
        const value = obj[key];
        if (typeof value !== 'object')
            return;
        addStoreMethods(value);
    });
};
